include "basics/pts.ma".
include "logic.ma".
definition transitive : \forall A : Type[0] . (A -> A -> Prop) -> Prop := \lambda A : Type[0]. \lambda R : A -> A -> Prop. \forall (x:A). \forall (y:A). \forall (z:A). (R x y) -> (R y z) -> R x z.
definition commutative : \forall A : Type[0] . (A -> A -> A) -> Prop := \lambda A : Type[0]. \lambda f : A -> A -> A. \forall (x:A). \forall (y:A). (eq) (A) (f x y) (f y x).
definition associative : \forall A : Type[0] . (A -> A -> A) -> Prop := \lambda A : Type[0]. \lambda f : A -> A -> A. \forall (x:A). \forall (y:A). \forall (z:A). (eq) (A) (f (f x y) z) (f x (f y z)).
definition monotonic : \forall A : Type[0] . (A -> A -> Prop) -> (A -> A) -> Prop := \lambda A : Type[0]. \lambda R : A -> A -> Prop. \lambda f : A -> A. \forall (x:A). \forall (y:A). (R x y) -> R (f x) (f y).
